# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class Setting(pulumi.CustomResource):
    """
    Manages an AutoScale Setting which can be applied to Virtual Machine Scale Sets, App Services and other scalable resources.
    """
    def __init__(__self__, __name__, __opts__=None, enabled=None, location=None, name=None, notification=None, profiles=None, resource_group_name=None, tags=None, target_resource_id=None):
        """Create a Setting resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if enabled and not isinstance(enabled, bool):
            raise TypeError('Expected property enabled to be a bool')
        __self__.enabled = enabled
        """
        Specifies whether automatic scaling is enabled for the target resource. Defaults to `true`.
        """
        __props__['enabled'] = enabled

        if not location:
            raise TypeError('Missing required property location')
        elif not isinstance(location, basestring):
            raise TypeError('Expected property location to be a basestring')
        __self__.location = location
        """
        Specifies the supported Azure location where the AutoScale Setting should exist. Changing this forces a new resource to be created.
        """
        __props__['location'] = location

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Specifies the name of the profile.
        """
        __props__['name'] = name

        if notification and not isinstance(notification, dict):
            raise TypeError('Expected property notification to be a dict')
        __self__.notification = notification
        """
        Specifies a `notification` block as defined below.
        """
        __props__['notification'] = notification

        if not profiles:
            raise TypeError('Missing required property profiles')
        elif not isinstance(profiles, list):
            raise TypeError('Expected property profiles to be a list')
        __self__.profiles = profiles
        """
        Specifies one or more (up to 20) `profile` blocks as defined below.
        """
        __props__['profiles'] = profiles

        if not resource_group_name:
            raise TypeError('Missing required property resource_group_name')
        elif not isinstance(resource_group_name, basestring):
            raise TypeError('Expected property resource_group_name to be a basestring')
        __self__.resource_group_name = resource_group_name
        """
        The name of the Resource Group in the AutoScale Setting should be created. Changing this forces a new resource to be created.
        """
        __props__['resourceGroupName'] = resource_group_name

        if tags and not isinstance(tags, dict):
            raise TypeError('Expected property tags to be a dict')
        __self__.tags = tags
        """
        A mapping of tags to assign to the resource.
        """
        __props__['tags'] = tags

        if not target_resource_id:
            raise TypeError('Missing required property target_resource_id')
        elif not isinstance(target_resource_id, basestring):
            raise TypeError('Expected property target_resource_id to be a basestring')
        __self__.target_resource_id = target_resource_id
        """
        Specifies the resource ID of the resource that the autoscale setting should be added to.
        """
        __props__['targetResourceId'] = target_resource_id

        super(Setting, __self__).__init__(
            'azure:autoscale/setting:Setting',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'enabled' in outs:
            self.enabled = outs['enabled']
        if 'location' in outs:
            self.location = outs['location']
        if 'name' in outs:
            self.name = outs['name']
        if 'notification' in outs:
            self.notification = outs['notification']
        if 'profiles' in outs:
            self.profiles = outs['profiles']
        if 'resourceGroupName' in outs:
            self.resource_group_name = outs['resourceGroupName']
        if 'tags' in outs:
            self.tags = outs['tags']
        if 'targetResourceId' in outs:
            self.target_resource_id = outs['targetResourceId']
