# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class TriggerRecurrence(pulumi.CustomResource):
    """
    Manages a Recurrence Trigger within a Logic App Workflow
    """
    def __init__(__self__, __name__, __opts__=None, frequency=None, interval=None, logic_app_id=None, name=None):
        """Create a TriggerRecurrence resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not frequency:
            raise TypeError('Missing required property frequency')
        elif not isinstance(frequency, basestring):
            raise TypeError('Expected property frequency to be a basestring')
        __self__.frequency = frequency
        """
        Specifies the Frequency at which this Trigger should be run. Possible values include `Month`, `Week`, `Day`, `Hour`, `Minute` and `Second`.
        """
        __props__['frequency'] = frequency

        if not interval:
            raise TypeError('Missing required property interval')
        elif not isinstance(interval, int):
            raise TypeError('Expected property interval to be a int')
        __self__.interval = interval
        """
        Specifies interval used for the Frequency, for example a value of `4` for `interval` and `hour` for `frequency` would run the Trigger every 4 hours.
        """
        __props__['interval'] = interval

        if not logic_app_id:
            raise TypeError('Missing required property logic_app_id')
        elif not isinstance(logic_app_id, basestring):
            raise TypeError('Expected property logic_app_id to be a basestring')
        __self__.logic_app_id = logic_app_id
        """
        Specifies the ID of the Logic App Workflow. Changing this forces a new resource to be created.
        """
        __props__['logicAppId'] = logic_app_id

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Specifies the name of the Recurrence Triggers to be created within the Logic App Workflow. Changing this forces a new resource to be created.
        """
        __props__['name'] = name

        super(TriggerRecurrence, __self__).__init__(
            'azure:logicapps/triggerRecurrence:TriggerRecurrence',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'frequency' in outs:
            self.frequency = outs['frequency']
        if 'interval' in outs:
            self.interval = outs['interval']
        if 'logicAppId' in outs:
            self.logic_app_id = outs['logicAppId']
        if 'name' in outs:
            self.name = outs['name']
